<script>

	import { onMount, onDestroy, beforeUpdate, afterUpdate, createEventDispatcher } from 'svelte';
	import Cell from './Cell.svelte';
	import Item from './Item.svelte';

	const dispatch = createEventDispatcher();
	
	const GRID_SIZE = 100;

	export let playerRoles      = [];
	export let cls              = '';
	export let raw              = false;
	export let filter           = e => true;
	export let _id              = '';
	export let rows             = 0;
	export let cols             = 0;
	export let items            = [];
	export let name             = '';
	export let label            = '';
	export let grid             = [];
	export let drag             = null;
	export let currentContainer = null;
	export let currentItem      = null;
	export let mouseX           = 0;
  export let mouseY           = 0;
	export let dragCount        = 0;

	export let getShape       = null;
	export let computeShapes  = null;
	export let check          = null;
	export let getImage       = null;
	export let setDraggedItem = null;
  export let getCache       = null;
	export let setDragCount   = null;
	
	export let isBody = false;

	let _items       = [];
	let _draggedItem = null;

  /* methods */
	function getGrid() {

		const grid = [];

		for(let y=0; y<rows; y++) {
			
			grid[y] = [];

			for(let x=0; x<cols; x++)
				grid[y][x] = false;
		}

		return grid;

	};

	/* callbacks */
	function onCellHover(e) {
		dispatch('cell_hover',{container: _id, x: e.detail.x, y: e.detail.y});
	}

	function onCellBlur(e) {
		dispatch('cell_blur',{container: _id, x: e.detail.x, y: e.detail.y});
	}

	beforeUpdate(() => {

		grid = getGrid();

		if(rows === -1)
      raw = true;
    else
			raw = false;
			
		_items = items.filter(filter);

		if(drag !== null && currentContainer && currentContainer._id === _id)
			_draggedItem = getCache().items[drag];

	})

</script>

<style>

	.container {
		position: relative;
		overflow: visible;
		margin-top: 32px;
	}

	.container-grid {
		position: relative;
    user-select: none;
	}

	.container-items {
		position: absolute;
    top: 0;
    left: 0;
	}
	
	.container-label {
    user-select: none;
    position: absolute;
    z-index: 1;
    background-color: rgba(125, 125, 125, 0.25);
    left: 0;
    width: calc(100% - 11px);
    height: 19px;
    padding: 5px;
    text-align: center;
    border: 1px solid rgba(255, 255, 255, 0.1);;
    transform: translate(0, -31px);
    color: #FFF;
	}

	.container.raw {
		min-height: 400px;
	}

	.container.raw .container-grid {
		position: unset;
		height: 100%;
	}

	.container.raw .container-items {
		position: unset;
    display: flex;
    flex-direction: row;
		flex-wrap: wrap;
		padding: 10px
	}

	.identity-container-body {
		position: absolute;
		width: 100px;
		height: 100px;
		transform: translate(-50%, -50%);
	}

	.identity-container-body.raw .container-items {
		position: absolute;
	}

	.identity-container-body.raw {
		min-height: unset;
	}

	.identity-container-component-4 { /* Pantalon */
		left: 35%;
		top: 70%;
	}

	.identity-container-component-5 { /* Mains (sac) */
		left: 10%;
		top: 25%;
	}

	.identity-container-component-6 { /* Chaussures */
		left: 71%;
		top: 87%;
	}

	.identity-container-component-7 { /* Chaine */
		left: 10%;
		top: 10%;
	}

	.identity-container-component-8 { /* Accesoires 1 (T-shirt) */
		left: 40%;
		top: 40%;
	}

	.identity-container-component-9 { /* Accesoires 2 (Pare-balle) */
		left: 60%;
		top: 40%;
	}

	.identity-container-component-11 { /* Torse */
		left: 50%;
		top: 25%;
	}

	.identity-container-prop-0{ /* Casque */
		left: 50%;
		top: 10%;
	}

	.identity-container-prop-1 { /* Lunettes */
		left: 30%;
		top: 10%;
	}

	.identity-container-prop-2 { /* Oreilles */
		left: 70%;
		top: 10%;
	}

	.identity-container-prop-6 { /* Montre */
		left: 25%;
		top: 55%;
	}

	.identity-container-prop-7 { /* Bracelet */
		left: 75%;
		top: 55%;
	}

</style>

<div class="container {raw ? 'raw' : ''} {cls}" style="width:{cols * GRID_SIZE + 1}px; height:{rows * GRID_SIZE + 1}px" data-id={_id}>
	<div class="container-label">
		{label}
	</div>
	<div class="container-grid">
		{#if raw}
			<Cell x={0} y={0} raw={true} on:hover={onCellHover} on:blur={onCellBlur}/>
		{:else}
			{#each grid as row, y}
				{#each row as cell, x}
					<Cell x={x} y={y} on:hover={onCellHover} on:blur={onCellBlur}/>
				{/each}
			{/each}
		{/if}
	</div>
	<div class="container-items">
		{#each _items as item, i}
			{#if item && (item.count > 0) && (item._id !== drag)}
				<Item
					{playerRoles}
					{...item}
					container={_id}
					{isBody}
					{raw}
					{drag}
					{currentContainer}
					{currentItem}
					{mouseX}
					{mouseY}
					{getShape}
					{computeShapes}
					{check}
					{getImage}
					{setDraggedItem}
					{getCache}
          {setDragCount}
				/>
			{/if}
		{/each}
		{#if !isBody && (drag !== null) && currentContainer && (currentContainer._id === _id)}
			<Item
				{playerRoles}
				{..._draggedItem}
				count={dragCount}
				container={_id}
				{isBody}
				{raw}
				{drag}
				{currentContainer}
				{currentItem}
				{mouseX}
				{mouseY}
				{getShape}
				{computeShapes}
				{check}
				{getImage}
				{setDraggedItem}
				{getCache}
				[setDragCount]
			/>
		{/if}
	</div>
</div>